With System;
Use System;
Package Body RhpAnim Is

    Procedure Pack_Cleanup (
          Anim_Pack : Package_Acc_T ); 
    Pragma Import(C, Entity => Pack_Cleanup,External_Name =>"anim_pack_cleanup");

    Procedure Cls_Cleanup (
          Anim_Class : Class_Acc_T ); 
    Pragma Import(C, Entity => Cls_Cleanup,External_Name =>"anim_cls_cleanup");

    Function Anim_Init (
          Port : Integer; 
          Host : String_address) 
      Return Boolean; 
    Pragma Import(C, Entity => Anim_Init,External_Name =>"anim_init");

    Function CStr (
          AdaString : String ) 
      Return String Is 
    Begin
        Return AdaString & Character'First;
    End CStr;


    Function Init (
          Port : Integer; 
          Host : String)   Return Boolean is
	CHost: String(host'first..host'last) := Host;
	begin 
		return Anim_Init(Port,CHost'address);
    end Init;

 Procedure Add_Attribute (
          AttrName       : String;        
          AttrValue      : System.Address;       
          Anim_Attr_List : System.Address ) Is 
		CAttrName: String := Cstr(AttrName);
	Begin
        Add_Address_Attribute(CAttrName'address, AttrValue, Anim_Attr_List);
    End Add_Attribute;

    Procedure Add_Attribute (
          AttrName       : String ;        
          AttrValue      : Integer;       
          Anim_Attr_List : System.Address ) Is 
		CAttrName: String := Cstr(AttrName);
	Begin
        Add_Integer_Attribute(CAttrName'address, AttrValue, Anim_Attr_List);
    End Add_Attribute;

    Procedure Add_Attribute (
          AttrName       : String;        
          AttrValue      : Long_Float;         
          Anim_Attr_List : System.Address ) Is 
		CAttrName: String := Cstr(AttrName);
    Begin
        Add_Long_Float_Attribute(CAttrName'address, AttrValue, Anim_Attr_List);
    End Add_Attribute;

    Procedure Add_Attribute (
          AttrName       : String;        
          AttrValue      : Float;         
          Anim_Attr_List : System.Address ) Is 
		CAttrName: String := Cstr(AttrName);
    Begin
        Add_Float_Attribute(CAttrName'address, AttrValue, Anim_Attr_List);
    End Add_Attribute;

    Procedure Add_Attribute (
          AttrName       : String;        
          AttrValue      : Boolean;       
          Anim_Attr_List : System.Address ) Is 
		CAttrName: String := Cstr(AttrName);
    Begin
        Add_Boolean_Attribute(CAttrName'address, AttrValue, Anim_Attr_List);
    End Add_Attribute;

    Procedure Add_Attribute (
          AttrName       : String;        
          AttrValue      : Duration;      
          Anim_Attr_List : System.Address ) Is 
		CAttrName: String := Cstr(AttrName);
    Begin
	Add_Long_Float_Attribute(CAttrName'address, Long_Float(AttrValue), Anim_Attr_List);
    End Add_Attribute;

    Procedure Add_Attribute (
          AttrName       : String;        
          AttrValue      : String;        
          Anim_Attr_List : System.Address ) Is
		CAttrName: String := Cstr(AttrName);
		CAttrValue : String := CStr(AttrValue);
    Begin
        Add_String_Attribute(CAttrName'address, CAttrValue'address, Anim_Attr_List);
    End Add_Attribute;

    Procedure Add_Attribute (
          AttrName       : String;        
          AttrValue      : Character;     
          Anim_Attr_List : System.Address ) Is 
		CAttrName: String := Cstr(AttrName);
    Begin
        Add_Character_Attribute(CAttrName'address, AttrValue'address, Anim_Attr_List);
    End Add_Attribute;


    Procedure Get_Attribute (
          This     : System.Address; 
          Data     : System.Address; 
          Position : System.Address  ) Is 
    Begin
        Get_Pointer_Attribute (This, Data, Position);
    End Get_Attribute;

    Procedure Get_Attribute (
          AttrValue : in out Integer;        
          Data      : System.Address; 
          Position  : System.Address  ) Is
        tmp : Integer; 
    Begin
        Get_Integer_Attribute (Tmp'Address, Data, Position);
        AttrValue := tmp;
    End Get_Attribute;


    Procedure Get_Attribute (
          AttrValue : in out Float;          
          Data      : System.Address; 
          Position  : System.Address  ) Is 
    Begin
        Get_Float_Attribute (AttrValue'address, Data, Position);
    End Get_Attribute;

    Procedure Get_Attribute (
          AttrValue : in out Long_Float;          
          Data      : System.Address; 
          Position  : System.Address  ) Is 
    Begin
        Get_Long_Float_Attribute (AttrValue'address, Data, Position);
    End Get_Attribute;


    Procedure Get_Attribute (
          AttrValue : in out Boolean;        
          Data      : System.Address; 
          Position  : System.Address  ) Is 
    Begin
        Get_Boolean_Attribute (AttrValue'address, Data, Position);
    End Get_Attribute;


    Procedure Get_Attribute (
          AttrValue : in out Duration;       
          Data      : System.Address; 
          Position  : System.Address  ) Is
		  tmp: Long_Float; 
    Begin
        Get_Long_Float_Attribute (tmp'address, Data, Position);
		AttrValue := Duration(tmp);
    End Get_Attribute;


    Procedure Get_Attribute (
          AttrValue : in out String;         
          Data      : System.Address; 
          Position  : System.Address  ) Is 
    Begin
        Get_String_Attribute (AttrValue'address, Data, Position);
    End Get_Attribute;


    Procedure Get_Attribute (
          AttrValue : in out Character;      
          Data      : System.Address; 
          Position  : System.Address  ) Is 
    Begin
        Get_Character_Attribute (AttrValue'address, Data, Position);
    End Get_Attribute;


    Procedure Class_Cleanup (
          Anim_Class : Class_Acc_T ) Is 
    Begin
        If Anim_Class /= RhpAnim.ZNIL Then
            Cls_Cleanup(Anim_Class);
        End If;
    End Class_Cleanup;


    Procedure Package_Cleanup (
          Anim_Pack : Package_Acc_T ) Is 
    Begin
        If Anim_Pack /= RhpAnim.ZNIL Then
            Pack_Cleanup(Anim_Pack);
        End If;
    End Package_Cleanup;
  
    Procedure Wakeup_event_queue(
            signal_ptr :  RiA_Event_Flag_Ada83.RiA_Event_Flag_Ada83_Acc_T) Is 
    Begin
      RiA_Event_Flag_Ada83.Signal(signal_ptr.All); 
    end Wakeup_event_queue;

    function Check_Stack_Growth_Direction(adressOfHisLocal: System.address) return boolean is
       myLocal: Integer;
    begin
       if adressOfHisLocal> myLocal'address then
	  return true;
       else
	  return false;
       end if;
    end Check_Stack_Growth_Direction;

    function Is_Stack_Growing_Down return boolean is
       local: Integer;
    begin
       return Check_Stack_Growth_Direction(local'address);
    end Is_Stack_Growing_Down;

    
    task body RiA_Connection_task is
       is_initialized : boolean:= false;
	   me: System.address;
    begin
    	loop
 	  select
	    when (is_initialized = false) =>
   			accept Start (this : in System.Address) do
  				if is_initialized = false then
					Me:= this;
					InitCommunicationLayer;
	   				is_initialized := true;
				end if;
			end Start;
		or
	    when (is_initialized = true) =>
			delay 0.0;
			Read_From_Socket(me);
	  end select;
	end loop;
    end RiA_Connection_task;
    
    procedure Connect_To_Socket(this : in System.Address) is
     begin
       RiA_Connection_task.Start(this);
    end Connect_To_Socket;


    procedure Initialize(this : in out Enter_Exit) is
    begin
      null;
    end Initialize;

    procedure Finalize(this : in out Enter_Exit) is
    begin
        Notify_End_Operation;
    end Finalize;
    procedure Initialize(this : in out Enter_Exit_Constructor) is
    begin
      null;
    end Initialize;

    procedure Finalize(this : in out Enter_Exit_Constructor) is
    begin
        Notify_End_Constructor;
    end Finalize;
	
    procedure ada_timer_suspend is
    begin
        Null;
    end ada_timer_suspend;
 
    procedure ada_timer_resume is
    begin
        Null;
    end ada_timer_resume;
	

end RhpAnim;
